//////////////////////////////////////////////////////////////////////////
//Kaptitel Prozeduren; Weichnzeichnen
//////////////////////////////////////////////////////////////////////////
PImage bild;
float[][] faltungsMatrix = {{1f/9, 1f/9, 1f/9}, {1f/9, 1f/9, 1f/9}, {1f/9, 1f/9, 1f/9}};
int x,y;


void setup() {
  size(300, 300);
  bild = loadImage( "bild.jpg");
  int h = bild.height;
  int w = bild.width; 
  surface.setResizable(true); 
  surface.setSize(w, h); 
  bildBearbeiten();
}

void bildBearbeiten() {
  PImage tmpBild = bild.get();  
  for (x = 1; x < bild.width-1; x++ ) 
    for (y = 1; y < bild.height-1; y++ )  
      if ( x<= width/2)  //Bereich Filter
        tmpBild.set(x,y,filterFaltung());
  bild = tmpBild; 
}

color filterFaltung() { 
  float rotAnteil = 0.0,gruenAnteil = 0.0,blauAnteil = 0.0;
  for (int i = 0; i <= 2; i++ ) { 
    for (int j = 0; j <= 2; j++ ) {
      color c = bild.get(x+i-1,y+j-1); 
      rotAnteil += red(c) * faltungsMatrix[i][j]; 
      gruenAnteil += green(c) * faltungsMatrix[i][j]; 
      blauAnteil += blue(c) * faltungsMatrix[i][j];
    }
  }
  return color(rotAnteil, gruenAnteil, blauAnteil); 
}

void draw(){
  image(bild, 0, 0);
  stroke(255,0,0);
  line(width/2,0,width/2,height);
  noLoop();
}
